#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define TRUE 1
#define FALSE 0
#define INF (-1)
#define NEDEFINISANO (-100)

typedef struct cvor
{
	int u,
	int v,
	int l
} CVOR;

int **graf, *prethodni,*obidjen,n,m,p,q;
CVOR *cvorovi;

int jeManji(int x,int y)
{
	if(x==INF) return FALSE;
	if(y==INF) return TRUE;
	return (x<y);
}

void stampajPut(int pom)
{
	if(prethodni[pom]!=INF)
	{
	    stampajPut(prethodni[pom]);
	    printf("%d ", prethodni[pom]);
	}
	printf("%d ", pom);
}

int dajNajveceg()
{
	int i,index;
	int rez=INF;
	for(i=0;i<n;i++)
	{
		if(obidjen[i]!=INF && jeManji(prethodni[i] ,rez))
		{
			rez = prethodni[i];
			index = i;
		}
	}
	return rez;
}

main()
{
	int i,j,brojVojnika;
	scanf("%d", &n);
	scanf("%d", &m);
	graf=(int **)malloc(m*sizeof(int*));
	prethodni=(int *)malloc(m*sizeof(int));
	obidjen=(int *)malloc(m*sizeof(int));
	cvorovi=(CVOR *)malloc(m*sizeof(CVOR));
	for(i=0;i<m;i++){
		graf[i]=(int *)malloc(m*sizeof(int));
	}
	
	for(i=0;i<m;i++){
		int u;
		int v;
		int l;
		scanf("%d%d%d",&u,&v,&l);
		graf[u][v]=graf[v][u]=l;
		//graf[i].u = u;
		//graf[i].v = v;
		//graf[i].l = l;
		//graf[i][j] = graf[j][i] = l;
		cvorovi[i].u = u;
		cvorovi[i].v = v;
		cvorovi[i].l = l;
		//graf[i][j] = graf[j][i] = l;
		obidjen[i] = INF;
	}
	
	scanf("%d", &p);
	scanf("%d", &q);
	brojVojnika = q;
	
	int naj;
	int deljenje;
	
// for(i=0;i<m;i++)
	//for(j=0;j<m;j++)
	while(naj = dajNajveceg())
	{
		if(obidjen[i]==INF)
		{
			if((deljenje = naj-1/p) > 0)
			{
			 brojVojnika = brojVojnika + (q*deljenje);
			 obidjen[i]= TRUE;
			}
		}
	}
	printf("%d\n",brojVojnika);
}


